#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "correlation.h"
#include "defs.h"
#include "main.h"

#include "opengl.h"
#include "openglgtk.h"

#include "latecki.h"

#define Onglet    {{"fixed_images"},{"fixed_normal"},{'\0'}}
#define Drawing   {{"drawing0"},{"drawing1"},{'\0'}}
#define InDrawing {{"image"},{"point"},{"point_count"},{"scanline"},{"scanline_count"},{'\0'}}
#define ONGLET      0
#define DRAWING     1
#define INDRAWING   2

extern GtkWidget *window_correlation;
extern GtkWidget *Application;

motion_t motion=done;
state_motion_t state_motion=available;


char WidgetTree[3][6][20]={
                          Onglet,
			  Drawing,
			  InDrawing
		      };

 
void
on_nouveau1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_ouvrir1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_enregistrer1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_enregistrer_sous1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_quitter1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_couper1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copier1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_coller1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_supprimer1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on____propos1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}
/*
 *   Récupération de la structure de base
 */
int Structure(GtkWidget *widget,pair_t **pair)
{
    (*pair)  = (pair_t*)lookup_widget((GtkWidget*)widget, "pair");
    return 0;
}

/*
 *  Processus disponible
 */
int Tracking(GtkWidget *widget)
{
    printf("Track\n");
    pair_t *structure;
    Structure(widget,&structure);
    if(singularities(&(structure->image[LEFT]),
                     &(structure->projection[LEFT]),
                     &(structure->image[RIGHT]),
                     &(structure->projection[RIGHT]))==-1)
      return -1;

    return 0;
}
int Correlation_Release_( correlation_t *correlation)
{
    if(!correlation)
     return 0;
   
    if(correlation->Map)
    {
        if(correlation->Map->elem)
	{
            free(correlation->Map->elem);
	    correlation->Map->elem=NULL;
	}
	free(correlation->Map);
	correlation->Map=NULL;
    }
    return 0;
}

int Image_Release_(pair_t *structure)
{
   image_free(&(*structure).image[LEFT]);
   image_free(&(*structure).image[RIGHT]);

   image_free(&(*structure).image_norm[LEFT]);
   image_free(&(*structure).image_norm[RIGHT]);

   image_free(&(*structure).depthmap[LEFT]);
   image_free(&(*structure).depthmap[RIGHT]);
        
   image_free(&(*structure).depthmap_norm[LEFT]);
   image_free(&(*structure).depthmap_norm[RIGHT]);
 
   return 0;
}

//int Tracking_Release_(GtkWidget *widget)
int Tracking_Release_(projection_t* projection)
{
    int i;
    for(i=(*projection).ptsing_count ; i>0 ; i--)
        array_del((*projection).ptsing,i);
   return 0;
}

int Tracking_Release(GtkWidget *widget)
{
    int i;
    pair_t *structure;
    Structure(widget,&structure);
    printf("tracked before : %d/%d\n",structure->projection[LEFT].ptsing_count,structure->projection[RIGHT].ptsing_count);
    for(i=structure->projection[LEFT].ptsing_count; i>0; i--)
        array_del(structure->projection[LEFT].ptsing,i);
    for(i=structure->projection[RIGHT].ptsing_count; i>0; i--)
        array_del(structure->projection[RIGHT].ptsing,i);
    printf("tracked released : %d/%d (%p/%p)\n",structure->projection[LEFT].ptsing_count, structure->projection[RIGHT].ptsing_count,
                                                structure->projection[LEFT].ptsing      , structure->projection[RIGHT].ptsing);
    return  0;
}
int Scanlines(GtkWidget *widget)
{
    printf("Scanlines\n");
    pair_t *structure;
    Structure(widget,&structure);
    /*Scanlines*/
    if(scanlines(&(structure->image[LEFT]),
                 &(structure->projection[LEFT]),
                 &(structure->image[RIGHT]),
                 &(structure->projection[RIGHT])))
        return -1;
    /*Paramètres et limites gauche*/
    if(parameters(&(structure)->image[LEFT],
                  &(structure)->projection[LEFT])==-1)
        return -1;
    if(limits(&(structure)->image[LEFT],
              &(structure)->projection[LEFT])==-1)
        return -1;
    /*Paramètres et limites droite*/
    if(parameters(&(structure)->image[RIGHT],
                  &(structure)->projection[RIGHT])==-1)
	return -1;
    if(limits(&(structure)->image[RIGHT],
              &(structure)->projection[RIGHT])==-1)
		return -1;

    if(adjust(structure))
         return -1;

    
    return 0;
}
int Scanline_Release_(projection_t *projection)
{
    int i;
    for(i=(*projection).scanline_count ; i>0 ; i--)
        array_del((*projection).scanline,i);
   return 0;
}

int Scanline_Release(GtkWidget *widget)
{
    int i;
    pair_t *structure;
    Structure(widget,&structure);
    printf("scanline before : %d/%d\n",structure->projection[LEFT].scanline_count,structure->projection[RIGHT].scanline_count);
    for(i=structure->projection[LEFT].scanline_count; i>0; i--)
        array_del(structure->projection[LEFT].scanline,i);
    for(i=structure->projection[RIGHT].scanline_count; i>0; i--)
        array_del(structure->projection[RIGHT].scanline,i);
    printf("tracked released : %d/%d\n (%p/%p)",structure->projection[LEFT].scanline_count, structure->projection[RIGHT].scanline_count,
                                                structure->projection[LEFT].scanline      , structure->projection[RIGHT].scanline);
    return  0;
}

/*
 *  Boite de dialogue d'erreur
 */
int DialogError(gchar *Error)
{
    GtkWidget *pDialog;
    pDialog = gtk_message_dialog_new(NULL,
        			     GTK_DIALOG_MODAL,
	                	     GTK_MESSAGE_ERROR,
	                	     GTK_BUTTONS_OK,
	                	     Error);
    gtk_dialog_run(GTK_DIALOG(pDialog));
    gtk_widget_destroy(pDialog);
    return 0;
}
/*
 *   Gestion ouverture de fichiers
 */
int FileDialog(GtkWidget *button,gchar ***sChemin)
{
    int i,cpt;
    GtkWidget *pFileSelection;
    gchar *sUtf8;
    /* Creation du titre de la fenetre */
    sUtf8 = g_locale_to_utf8("Select files", -1, NULL, NULL, NULL);
    /* Creation de la fenetre de multi selection */
    pFileSelection = gtk_file_selection_new(sUtf8);
	gtk_file_selection_set_select_multiple((GtkFileSelection*)pFileSelection,1);
    /* On limite les actions a cette fenetre */
    gtk_window_set_modal(GTK_WINDOW(pFileSelection), TRUE);
    /* Liberation memoire */
    g_free(sUtf8);
    sUtf8 = NULL;   
    /* Affichage fenetre */
    switch(gtk_dialog_run(GTK_DIALOG(pFileSelection)))
    {
        case GTK_RESPONSE_OK:
	    *sChemin = gtk_file_selection_get_selections(GTK_FILE_SELECTION(pFileSelection));
            for(i=0,cpt=0; (*sChemin)[i];i++)
        		cpt++;
            printf("%d file(s) loaded\n",cpt);
	    break;
        default:
	    printf("Cancelled\n"); 
            cpt = -1;
            break;
    }
    gtk_widget_destroy(pFileSelection);
    return cpt;
}
/*
 *   Ouverture fichier
 */
void
on_toolopen_clicked                    (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
    gchar **Chemin;
    pair_t *structure;
    int cpt;
    double factor;
    gchar *text;
    GtkWidget *drawing,*parent,*resol,*parenthandle;
    printf("Open button pushed\n");
    /*Ouverture boite de dialogue*/
    cpt = FileDialog((GtkWidget*)(toolbutton),&Chemin);
    if(cpt == -1)
     return;
    Structure((GtkWidget*)toolbutton,&structure);
    printf("pair = %p\n",structure);
    /*Récupération de la résolution de l'image*/
    resol = lookup_widget((GtkWidget*)toolbutton,"spinbutton_resol");
    text = gtk_editable_get_chars(GTK_EDITABLE (resol),0,-1);
    factor = atof(text);
    printf("factor : %f\n",factor);
    /*Lecture des fichiers*/
    switch(gtkLoadImage(Chemin,(pair_t*)structure,factor))
    {
        case -1 :
           DialogError("Erreur d'ouverture"); 
	   return;
	   break;
        case 1:
           DialogError("Deux images nécessaires"); 
	   return;
           break;	  
	default:
	   printf("load done...\n");
    }
    
    /*Création des drawing area gauche */
    drawing = gtk_drawing_area_new();
    parent = lookup_widget((GtkWidget*)toolbutton, "fixed_images");
    parenthandle = lookup_widget((GtkWidget*)toolbutton, "fixed_handle");
/*    CreateDrawing(parenthandle,
  		  drawing,
		  "drawing0",
		  0,0,400,400);
*/
    CreateDrawing(parent,
  		  drawing,
		  "drawing0",
		  0,0,400,400);

    gtk_object_set_data ((GtkObject *)parent, "drawing0",drawing);      
//    gtk_object_set_data ((GtkObject *)parenthandle, "drawing0",drawing);      
    gtk_object_set_data ((GtkObject *)drawing, "image",&(structure->image[LEFT]));      
    
    /*Création des drawing area droite */
    drawing = gtk_drawing_area_new();
    CreateDrawing(parent,
  		  drawing,
		  "drawing1",
		  400,0,400,400);
    gtk_object_set_data ((GtkObject *)parent, "drawing1",drawing); 
    gtk_object_set_data ((GtkObject *)drawing, "image",&(structure->image[RIGHT]));  
    
    /*Création des drawing area de la ligne*/
    drawing = gtk_drawing_area_new();
    parenthandle = lookup_widget((GtkWidget*)window_correlation, "fixed_handle");
    CreateDrawing(parenthandle,
  		  drawing,
		  "line",
		  //0,0,400,TRANS_X);
		  0,0,10,100);
    gtk_object_set_data ((GtkObject *)parenthandle, "line",drawing); 
     
    
    gtk_object_set_data ((GtkObject *)Application, "status",(void*)(loaded));      
 }

void print_structure(pair_t *pair)
{
   //printf("structure : %p\n",*pair);
#if 0
   printf("Images     : %p %p\n",&(pair)->image[LEFT],
     				 &(pair)->image[RIGHT]);
   printf("Image_norm : %p %p\n",&(*pair).image_norm[LEFT],
     				 &(*pair).image_norm[RIGHT]);
   printf("Depth      : %p %p\n",&(*pair).depthmap[LEFT],
     				 &(*pair).depthmap[RIGHT]);
   printf("Depth_norm : %p %p\n",&(*pair).depthmap_norm[LEFT],
     				 &(*pair).depthmap_norm[RIGHT]);
   printf("projection : %p %p\n",&(*pair).projection[LEFT],
     				 &(*pair).projection[RIGHT]);
   printf("- point    : %p %p\n",(pair->projection[LEFT].ptsing),
     				 (pair->projection[RIGHT].ptsing));
   printf("- nb point : %d %d\n",(*pair).projection[LEFT].ptsing_count,
       				 (*pair).projection[RIGHT].ptsing_count);
   printf("- scanline : %p %p\n",(*pair).projection[LEFT].scanline,
     				 (*pair).projection[RIGHT].scanline);
   printf("- nb scan  : %d %d\n",(*pair).projection[LEFT].scanline_count,
     				 (*pair).projection[RIGHT].scanline_count);
#else
  printf("Images     : %p %p\n",(*pair).image[LEFT].pixels,
     				 (*pair).image[RIGHT].pixels);
  printf("  point    : %p %p\n",(*pair).projection[LEFT].ptsing,
     				 (*pair).projection[RIGHT].ptsing);
  printf(" nb point  : %d %d\n",(*pair).projection[LEFT].ptsing_count,
     				 (*pair).projection[RIGHT].ptsing_count);
  printf(" scanline  : %p %p\n",(*pair).projection[LEFT].scanline,
     				 (*pair).projection[RIGHT].scanline);
  printf("nb scanline: %d %d\n",(*pair).projection[LEFT].scanline_count,
     				 (*pair).projection[RIGHT].scanline_count);
  printf("Correlation: %p ",(*pair).correlation[LEFT].Map);
  if((*pair).correlation[LEFT].Map)
   printf("%p",(*pair).correlation[LEFT].Map->elem);
  printf("\n");



#endif


}

void
on_toolclose_clicked                   (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
    GtkWidget *fixed,*drawing;
    pair_t *structure;
//    image_t*img;
//    ptsing_t *pt;
//    scanline_t *scanline;
//    int nbonglet,nbdrawing,nbcontener;
    printf("Close button pushed\n");
    Structure((GtkWidget*)toolbutton,&structure);
    printf("*******************\nAvant\n**********************\n");
    print_structure(structure); 
#if 0
   /* Parcours des onglets */
   for(nbonglet = 0 ; WidgetTree[ONGLET][nbonglet][0] != '\0';nbonglet++)
   {
        fixed = lookup_widget((GtkWidget*)toolbutton, WidgetTree[ONGLET][nbonglet]);
	/*Parcours des drawing de l'onglet*/
        for(nbdrawing=0;WidgetTree[DRAWING][nbdrawing][0] != '\0';nbdrawing++)
	{
	    drawing = gtk_object_get_data ((GtkObject *)fixed, WidgetTree[DRAWING][nbdrawing]);          
	    /*Parcours des éléments des drawing*/
            for(nbcontener=0;WidgetTree[INDRAWING][nbcontener][0] != '\0';nbcontener++)
	    {
		if(strcmp(WidgetTree[INDRAWING][nbcontener],WidgetTree[INDRAWING][0])==0)
		{
		    image_t *img;
		}
		else if(strcmp(WidgetTree[INDRAWING][nbcontener],WidgetTree[INDRAWING][1])==0)
		{
		    pt


		}
	    }
	}

   }
#endif
        fixed = lookup_widget((GtkWidget*)toolbutton, "fixed_images");
        drawing = gtk_object_get_data ((GtkObject *)fixed, "drawing0");          
	printf("drawing0 : %p\n",drawing);
        if(drawing)
	{
  		gtk_object_remove_data((GtkObject*)drawing,"image");
	        gtk_object_remove_data((GtkObject*)drawing,"point");
	        gtk_object_remove_data((GtkObject*)drawing,"point_count");
	        gtk_object_remove_data((GtkObject*)drawing,"scanline");
	        gtk_object_remove_data((GtkObject*)drawing,"scanline_count");
		gtk_object_remove_data((GtkObject*)fixed,"drawing0");
	        gtk_widget_destroy(drawing);
	}
	drawing = gtk_object_get_data ((GtkObject *)fixed, "drawing1");          
	printf("drawing1 : %p\n",drawing);
	if(drawing)
	{
 	        gtk_object_remove_data((GtkObject*)drawing,"image");
	        gtk_object_remove_data((GtkObject*)drawing,"point");
	        gtk_object_remove_data((GtkObject*)drawing,"point_count");
	        gtk_object_remove_data((GtkObject*)drawing,"scanline");
	        gtk_object_remove_data((GtkObject*)drawing,"scanline_count");
	  	gtk_object_remove_data((GtkObject*)fixed,"drawing1");
	        gtk_widget_destroy(drawing);
	}
	drawing = gtk_object_get_data ((GtkObject *)fixed, "line");          
	printf("line : %p\n",drawing);
	if(drawing)
	{
	        gtk_object_remove_data((GtkObject*)drawing,"image");
	        gtk_object_remove_data((GtkObject*)drawing,"point");
        	gtk_object_remove_data((GtkObject*)drawing,"point_count");
        	gtk_object_remove_data((GtkObject*)drawing,"scanline");
	        gtk_object_remove_data((GtkObject*)drawing,"scanline_count");
		gtk_object_remove_data((GtkObject*)fixed,"line");
	        gtk_widget_destroy(drawing);
	}

   	/*Suppression des images*/
	Image_Release_(structure);
        /*Suppression points du tracking*/	
	Tracking_Release_(&(*structure).projection[LEFT]);
	Tracking_Release_(&(*structure).projection[RIGHT]);
        /*Suppression scanlines*/
	Scanline_Release_(&(*structure).projection[LEFT]);
	Scanline_Release_(&(*structure).projection[RIGHT]);
        /*Suppression des strcutures de correlation*/
	Correlation_Release_(&(*structure).correlation[LEFT]);
	Correlation_Release_(&(*structure).correlation[RIGHT]);
#if 0    
    fixed = lookup_widget((GtkWidget*)toolbutton, "fixed_images");
    drawing = gtk_object_get_data ((GtkObject *)fixed, "drawing0");          
    /*Récupération du drwing*/
    if(!drawing)
    {
      printf("drawing not found\n");  
      return;
    }
    printf("drawing found\n");
    /*Récupération de l'image*/
    printf("%s found\n",drawing->name);
    img = gtk_object_get_data((GtkObject*)drawing,"image");
    gtk_object_remove_data((GtkObject*)drawing,"image");
    if(img)
    {
        printf("image found\n");
	image_free(&img);
    }
    else
     printf("image not found\n");
    
    /*Récupération des points*/
    pt = gtk_object_get_data((GtkObject*)drawing,"point");
    gtk_object_remove_data((GtkObject*)drawing,"point");
    gtk_object_remove_data((GtkObject*)drawing,"point_count");
    if(pt)
    {
        printf("points found\n");
	Tracking_Release_(&(*structure).projection[LEFT]);
    }
    else
     printf("points not found\n");
   /*Récupération des lignes*/
    scanline = gtk_object_get_data((GtkObject*)drawing,"scanline");
    gtk_object_remove_data((GtkObject*)drawing,"scanline");
    if(pt)
    {
	printf("scanlines found\n");
	Scanline_Release_(&(*structure).projection[LEFT]);

    }
    else
     printf("scanlines not found\n");
    /*Unstack object*/
    gtk_object_remove_data((GtkObject*)fixed,"drawing0");
    /*Destory object*/
    gtk_widget_destroy(drawing);
#endif
   
//    image_free((image_t**)(&(&(*structure).image[LEFT])));

    
    printf("*******************\nApres\n**********************\n");
    print_structure(structure); 
    return ;
#if 0 
    fixed = lookup_widget((GtkWidget*)toolbutton, "fixed_images");
    drawing = gtk_object_get_data ((GtkObject *)fixed, "drawing0");          
    if(!drawing)
      return;
    Tracking_Release_(drawing);  
    gtk_object_remove_data((GtkObject*)drawing,"point");
    gtk_object_remove_data((GtkObject*)drawing,"point_count");
    Scanline_Release_(drawing);  
    gtk_object_remove_data((GtkObject*)drawing,"scanline");
    gtk_object_remove_data((GtkObject*)drawing,"scanline_count");
//    gtk_object_remove_data((GtkObject*)drawing,"image");
//    gtkReleaseImage((GtkWidget*)drawing);

    
    
    drawing = gtk_object_get_data ((GtkObject *)fixed, "drawing1");          
    Tracking_Release_(drawing);  
    gtk_object_remove_data((GtkObject*)drawing,"point");
    gtk_object_remove_data((GtkObject*)drawing,"point_count");
    Scanline_Release_(drawing);  
    gtk_object_remove_data((GtkObject*)drawing,"scanline");
    gtk_object_remove_data((GtkObject*)drawing,"scanline_count");
    
//    gtk_object_remove_data((GtkObject*)drawing,"image");
//    gtkReleaseImage((GtkWidget*)drawing);

    gtk_object_set_data ((GtkObject *)fixed, "status",(void*)(loaded));     
    gtk_widget_queue_draw(fixed);
#endif
}


void
on_toolexecute_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
    GtkWidget *parent,*drawing,*version,*block;
    pair_t *structure;
    int state;
    //int vertrack; 
    gchar *text;
    printf("Execute button pushed\n");
    parent     = lookup_widget((GtkWidget*)toolbutton, "fixed_images");
    version     = lookup_widget((GtkWidget*)toolbutton, "combobox_tracking");
    block  = lookup_widget((GtkWidget*)toolbutton,"spinbutton_block");
    state   =(int)gtk_object_get_data((GtkObject*)Application,"status"); 
    Structure((GtkWidget*)toolbutton,&structure);
    /*Récupération de la version de tracking*/
    track_mode = 1<<((int)gtk_combo_box_get_active((GtkComboBox*)version));
    printf("tracking : %d\n",track_mode);
    /*Récupération du nombre de block du tracking*/
    text = gtk_editable_get_chars(GTK_EDITABLE (block),0,-1);
    size_mode = atof(text)*atof(text);
    printf("block : %d\n",size_mode);
    switch(state)
    {
        case none:
	     printf("not loaded..\n");
	     break;
        case loaded:
	     printf("just loaded\n");
	     /*Suivi des points*/
	     Tracking_Release((GtkWidget*)toolbutton);
	     Tracking((GtkWidget*)toolbutton);
	     /*Ajout des structures correspondantes*/
             drawing =     gtk_object_get_data((GtkObject*)parent, "drawing0");
	     gtk_object_set_data((GtkObject*)drawing,"point",structure->projection[LEFT].ptsing);
	     gtk_object_set_data((GtkObject*)drawing,"point_count",&(structure->projection[LEFT].ptsing_count));
	     drawing =     gtk_object_get_data((GtkObject*)parent, "drawing1");
	     gtk_object_set_data((GtkObject*)drawing,"point",structure->projection[RIGHT].ptsing);
             gtk_object_set_data((GtkObject*)drawing,"point_count",&(structure->projection[RIGHT].ptsing_count));      
	     /*Changement de status*/
             gtk_object_set_data ((GtkObject *)Application, "status",(void*)(tracking));      
//             break;
	case tracking:
	     printf("tracking done\n");
	     /*Calcul des scanlines et paramètres*/
	     Scanlines((GtkWidget*)toolbutton);
	     /*Ajout des structures correspondantes*/
             drawing =     gtk_object_get_data((GtkObject*)parent, "drawing0");
             gtk_object_set_data ((GtkObject *)drawing, "scanline",structure->projection[LEFT].scanline);
             gtk_object_set_data ((GtkObject *)drawing, "scanline_count",&(structure->projection[LEFT].scanline_count));
             drawing =     gtk_object_get_data((GtkObject*)parent, "drawing1");
             gtk_object_set_data ((GtkObject *)drawing, "scanline",structure->projection[RIGHT].scanline);
             gtk_object_set_data ((GtkObject *)drawing, "scanline_count",&(structure->projection[RIGHT].scanline_count));
	     
             gtk_object_set_data ((GtkObject *)Application, "status",(void*)(scanline));      
//	     break;
	case scanline:
	     printf("scanlines computed\n");
	     matching(structure);
             gtk_object_set_data ((GtkObject *)Application, "status",(void*)(match));
	     break;
	default:
	     printf("Not loaded\n");
    }
    gtk_widget_queue_draw(parent);
    print_structure(structure);
}


void
on_toolquit_clicked                    (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
    printf("Quit button pushed\n");
    gtk_exit(0);
}

/*
 *   Choix de la version de tracking
 */
void
on_combobox_tracking_changed           (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
    GtkWidget *parent;
    int state;
    printf("Change combox box tracking content\n");
    printf("\t%d\n",gtk_combo_box_get_active(combobox));
    parent     = lookup_widget((GtkWidget*)combobox, "fixed_images");
    state   =(int)gtk_object_get_data(GTK_OBJECT(parent),"status"); 
    state = loaded;
    gtk_object_set_data((GtkObject*)parent,"status",(void*)loaded); 

}
/*
 *   Choix du nombre de block pour le tracking
 */
void
on_spinbutton_block_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
    GtkWidget *parent;
    printf("Change block number\n");
    printf("\t%s\n",gtk_editable_get_chars(GTK_EDITABLE (editable),0,-1));
    parent     = lookup_widget((GtkWidget*)editable, "fixed_images");
    gtk_object_set_data((GtkObject*)parent,"status",(void*)loaded); 
}	

/*
 *    Choix de la résolution de l'image
 */
void
on_spinbutton_resol_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
    printf("Change resolution size\n");
    printf("\t%s\n",gtk_editable_get_chars(GTK_EDITABLE (editable),0,-1));
}

void
on_notebook_principal_switch_page      (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        guint            page_num,
                                        gpointer         user_data)
{
   GtkWidget *wid,*drawing;
   int state;
   static int norm = 0;
   static int depth= 0;
   static int opengl= 0;
   pair_t *structure;
   printf("Change notebook content\n");
   Structure((GtkWidget*)notebook,&structure);
   state = (int)gtk_object_get_data((GtkObject*)Application,"status");
   printf("\t%d\t\n",page_num);
   switch(page_num)
   {
        /*Onglet de normalisation*/
        case 1:
            if(state >= scanline && !norm)
	    {
	      norm=1;
	      printf("normalisation ok\n");
        if(normalise(&(structure->image[LEFT]),
                     &(structure->projection[LEFT]),
                     &(structure->image_norm[LEFT])))
            return ;
        if(normalise(&(structure->image[RIGHT]),
                     &(structure->projection[RIGHT]),
                     &(structure->image_norm[RIGHT])))
            return ;
	      wid = lookup_widget((GtkWidget*)notebook, "fixed_normalisation");
	      drawing = gtk_drawing_area_new();
	      CreateDrawing(wid,
  		            drawing,
		            "drawing0",
		            0,0,400,400);
	      gtk_object_set_data ((GtkObject *)wid, "drawing0",drawing);
		gtk_object_set_data ((GtkObject *)drawing, "image",&(structure->image_norm[LEFT]));
	      drawing = gtk_drawing_area_new();
	      CreateDrawing(wid,
  		            drawing,
		            "drawing1",
		            400,0,400,400);
	      gtk_object_set_data ((GtkObject *)wid, "drawing1",drawing);
		gtk_object_set_data ((GtkObject *)drawing, "image",&(structure->image_norm[RIGHT]));

	    }
	    else
	      printf("normalisation no\n");
	    break;
 	/*Carte de profondeur*/
	case 2:
            if(state >= match && !depth)
	    {
	      depth=1;
	      wid = lookup_widget((GtkWidget*)notebook, "fixed_map");
	      drawing = gtk_drawing_area_new();
	      CreateDrawing(wid,
  		            drawing,
		            "drawing0",
		            0,0,400,400);
	      gtk_object_set_data ((GtkObject *)wid, "drawing0",drawing);
		gtk_object_set_data ((GtkObject *)drawing, "image",&(structure->depthmap_norm[LEFT]));
	      drawing = gtk_drawing_area_new();
	      CreateDrawing(wid,
  		            drawing,
		            "drawing1",
		            400,0,400,400);
	      gtk_object_set_data ((GtkObject *)wid, "drawing1",drawing);

             image_copy(&(structure->depthmap_norm[RIGHT]), &(structure->depthmap_norm[LEFT]));  
	      
		gtk_object_set_data ((GtkObject *)drawing, "image",&(structure->depthmap_norm[RIGHT]));
	    }
	    break;

	case 3:
	    if(state >=match && !opengl && depth && norm)
	    {
	     opengl = 1;
	      Calcul_Projection(&(structure->image_norm[LEFT]),&(structure->depthmap_norm[LEFT]));
	      //Calcul_Projection(&(structure->image[LEFT]),&(structure->depthmap[LEFT]));
	    }
	    break;

   }
   return ;
}







gboolean
my_on_drawingarea1_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
   printf("*");
   fflush(stdout);
  return FALSE;
}
gboolean  Timer(gpointer data) 
{
  if(motion==asked && state_motion == available)
  {
    /*Unavailable*/
    state_motion = unavailable;
//    printf("motion computing\n");
    current_motion_t *current_motion;
    current_motion = get_current_motion(); 
    /*Construction de l'image de corrélation*/
    gtkCorrelation(current_motion);
//    printf("motion done\n");
    /*Available*/
     motion = done; 
     state_motion = available; 
  }
  return TRUE;
}
void
on_button_test_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

//    Map=structure->correlation[LEFT].Map;
 
   pair_t *structure;
   map_t *Map;
   double **tab,**tab_out;
   int i,j,nb,x,y,r,g,b;
   int min,max,l_seuil;
   static int iteration=0;
   Structure((GtkWidget*)button,&structure);
   Map = structure->correlation[LEFT].Map;

   
//   matching(structure);

//   gtk_object_set_data ((GtkObject *)Application, "status",(void*)(match));

//   return;

   iteration+=10;
#if 1 
   /*Vertical*/
   printf("passe vertical\n");
   tab = malloc(sizeof(double*)*Map->height);
   tab_out = malloc(sizeof(double*)*Map->height);
   for(i=0 ; i<Map->height ; i++)
   {
      tab[i] = malloc(sizeof(double)*2);
      tab_out[i] = malloc(sizeof(double)*2);
   }
    for(x=0 ; x < Map->width ; x++)
    {
        printf("\r %d %%", x*100 / Map->width);
	fflush(stdout);
	/* Récupération d'une ligne entière */
        for(y=0 ; y < Map->height ; y++)
	{
	   /*Construction de la ligne de correlation*/	
	   tab[y][0] = y;
	   //tab[x][1] = (Map->elem+y*Map->width+x)->depth;
	   getpixel_fast(&structure->depthmap_norm[LEFT],x,y,&r,&g,&b);
	   if(r==0 && g == 255 && b == 0)
	   { 
              /*Recheche du plus petit des points entourants (pixel du
	       * fond
	       **/
	       for(i=y ; ;i++)
	       {
	          getpixel_fast(&structure->depthmap_norm[LEFT],x,i,&r,&g,&b);
	          if(!(r==0 && g == 255 && b == 0))
                     break;
	       }
	       i = r;
	       for(j=y ; ;j--)
	       {
	          getpixel_fast(&structure->depthmap_norm[LEFT],x,j,&r,&g,&b);
	          if(!(r==0 && g == 255 && b == 0))
                     break;
	       }
	       j = r;
	       r = MIN(j,i);
	   }
	   tab[y][1] = r;
	}
	/*Compression*/
	nb = 0;
        Polygone(iteration,tab,Map->height,tab_out,&nb);
	/*Recopie de la compression*/
        for(y=0 ; y < Map->height ; y++)
	{
//	   if(tab_out[y][1] == -1)
//	      setpixel_fast(&structure->depthmap_norm[LEFT],x,y,0,255,0);
//	   else
	      setpixel_fast(&structure->depthmap_norm[LEFT],x,y,tab_out[y][1],tab_out[y][1],tab_out[y][1]);
	}
//	   (Map->elem+y*Map->width+x)->corr = tab_out[x][1];
    }
    printf("\r 100 %%\n");
    fflush(stdout);
   for(i=0 ; i<Map->height; i++)
   {
       free(tab[i]);
       free(tab_out[i]);
   }
   free(tab);
   free(tab_out);  
#endif 
   /*Horizontal*/
   printf("passe horizontal\n"); 
   tab = malloc(sizeof(double*)*Map->width);
   tab_out = malloc(sizeof(double*)*Map->width);
   for(i=0 ; i<Map->width ; i++)
   {
      tab[i] = malloc(sizeof(double)*2);
      tab_out[i] = malloc(sizeof(double)*2);
   }
    for(y=0 ; y < Map->height ; y++)
    {
        printf("\r %d %%", y*100 / Map->height);
	fflush(stdout);
	/* Récupération d'une ligne entière */
        for(x=0 ; x < Map->width ; x++)
	{
	   /*Construction de la ligne de correlation*/	
	   tab[x][0] = x;
	   //tab[x][1] = (Map->elem+y*Map->width+x)->depth;
	   getpixel_fast(&structure->depthmap_norm[LEFT],x,y,&r,&g,&b);
	   if(r==0 && g == 255 && b == 0)
	   { 
              /*Recheche du plus petit des points entourants (pixel du
	       * fond
	       **/
	       for(i=x ; ;i++)
	       {
	          getpixel_fast(&structure->depthmap_norm[LEFT],i,y,&r,&g,&b);
	          if(!(r==0 && g == 255 && b == 0))
                     break;
	       }
	       i = r;
	       for(j=x ; ;j--)
	       {
	          getpixel_fast(&structure->depthmap_norm[LEFT],j,y,&r,&g,&b);
	          if(!(r==0 && g == 255 && b == 0))
                     break;
	       }
	       j = r;
	       r = MIN(j,i);
	   }
	   tab[x][1] = r;
	}
	/*Compression*/
	nb = 0;
        Polygone(iteration,tab,Map->width,tab_out,&nb);
	/*Recopie de la compression*/
        //for(x=0 ; x < Map->width ; x++)
        for(x=0 ; x < Map->width ; x++)
	{
//	   if(tab_out[x][1] == -1)
//	      setpixel_fast(&structure->depthmap_norm[LEFT],x,y,0,255,0);
//	   else
	      setpixel_fast(&structure->depthmap_norm[LEFT],x,y,tab_out[x][1],tab_out[x][1],tab_out[x][1]);
	   //setpixel_fast(&structure->depthmap_norm[LEFT],x,y,tab_out[x][1],tab_out[x][1],tab_out[x][1]);
	   //(Map->elem+y*Map->width+x)->corr = tab_out[x][1];
	}
    }
    printf("\r 100 %%\n");
    fflush(stdout);
   for(i=0 ; i<Map->width; i++)
   {
       free(tab[i]);
       free(tab_out[i]);
   }
   free(tab);
   free(tab_out);  
   Calcul_Projection(&(structure->image_norm[LEFT]),&(structure->depthmap_norm[LEFT]));
#if 0
    /*Reconstruction de l'image */
    printf("reconstruction de la map\n");
    min = 999999; max = -999999;
    l_seuil = THRESH * 20;
    for(y=0 ; y<Map->height; y++)
    {
        for(x=0 ; x < Map->width; x++)
        {
            if((Map->elem+y*Map->width+x)->corr < l_seuil)
            {
                if((Map->elem+y*Map->width+x)->depth < min)
                    min = (Map->elem+y*Map->width+x)->corr;

                if((Map->elem+y*Map->width+x)->depth > max)
                    max = (Map->elem+y*Map->width+x)->corr;
            }
        }
    }
    printf("min/max : %d/%d\n",min,max);
    for(y=0 ; y<Map->height; y++)
    {
        for(x=0; x<Map->width; x++)
        {
/*            if((Map->elem+y*Map->width+x)->invalid)
                setpixel_fast(&structure->depthmap_norm[LEFT],x,y,0,255,0);
            else if((Map->elem+y*Map->width+x)->highlight)
                setpixel_fast(&structure->depthmap_norm[LEFT],x,y,255,255,0);
            else if((Map->elem+y*Map->width+x)->corr > seuil)
                setpixel_fast(&structure->depthmap_norm[LEFT],x,y,255,0,0);
            else*/
            {
                int pixel = ((float)(max - (Map->elem+y*Map->width+x)->corr)
                              / (float)(max - min)) * 255.;
                setpixel(&structure->depthmap_norm[LEFT], x, y, 
		         pixel, 
			 pixel, 
			 pixel);
            }
        }
    }
#endif
    
#if 0
    for(i=0 ; i < structure->correlation[LEFT].Map->width *structure->correlation[LEFT].Map->height ; i++ )
    {

        printf("\r %d %%", i*100 /(structure->correlation[LEFT].Map->height * structure->correlation[LEFT].Map->height));
	fflush(stdout);
        Convert_mapto_double(tab,&structure->correlation[LEFT].Map->elem[i]); 
        nb= 0;
        Polygone(iteration,tab,TRANS_X,tab_out,&nb);

        /*Recopie de la compression*/

	for(j=0 ; j<TRANS_X ; j++)
	{
		structure->correlation[LEFT].Map->elem[i].tabcorr[j] = tab_out[j][1];

	}
    }
#endif
 
 
/*   GtkWidget *wid;
   wid = lookup_widget((GtkWidget*)button,"custom_opengl");
   gtk_widget_set_size_request(wid,600,600);
//    gtk_widget_get_size_request(GtkWidget *widget,gint*width,gint*height);
*/
#if 0
   int nbonglet,nbdrawing,nbcontener;
   GtkWidget *toggle;
   toggle = lookup_widget((GtkWidget*)button, "checkbutton_point");
   printf("%d\n",gtk_toggle_button_get_active((GtkToggleButton*)toggle));

   gtk_timeout_add(500,(GtkFunction)Timer,0) ;

   return ;
  for(nbonglet=0;WidgetTree[ONGLET][nbonglet][0] != '\0';nbonglet++)
  {
	printf("%s\n",WidgetTree[ONGLET][nbonglet]);

	for(nbdrawing=0;WidgetTree[DRAWING][nbdrawing][0] != '\0';nbdrawing++)
	{
	    printf("\t%s\n",WidgetTree[DRAWING][nbdrawing]);
	   for(nbcontener=0;WidgetTree[INDRAWING][nbcontener][0] != '\0';nbcontener++)
	       printf("\t\t%s\n",WidgetTree[INDRAWING][nbcontener]);

	}

  }

 
  return ;
  GtkWidget *drawingarea1,*parent,*app;
  app  = lookup_widget((GtkWidget*)button, "Application");
  parent  = lookup_widget((GtkWidget*)button, "fixed_images");
  drawingarea1 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea1, "drawingarea");
  gtk_widget_show (drawingarea1);
  gtk_widget_set_events (drawingarea1, GDK_POINTER_MOTION_MASK);
  gtk_fixed_put (GTK_FIXED (parent), drawingarea1, 72, 64);
  gtk_widget_set_size_request (drawingarea1, 440, 344);
//  gtk_widget_set_events (drawingarea1, GDK_POINTER_MOTION_MASK);



 // gtk_widget_realize(drawingarea1);
    printf("7");fflush(stdout);
 g_signal_connect ((gpointer) drawingarea1, "motion_notify_event",
                    G_CALLBACK (my_on_drawingarea1_motion_notify_event),
                    NULL);
  printf("8");fflush(stdout);
// g_object_set_data(app,drawingarea1,"drawingarea");
#endif
}


void
on_checkbutton_point_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    GtkWidget *wid;
    wid = lookup_widget((GtkWidget*)togglebutton, "fixed_images");
    gtk_widget_queue_draw(wid);
}


void
on_checkbutton_scanline_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    GtkWidget *wid;
    wid = lookup_widget((GtkWidget*)togglebutton, "fixed_images");
    gtk_widget_queue_draw(wid);
}


void
on_checkbutton_corr_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    static int indic=0;
    static int id_timer;
    if(!indic)
    {
//       id_timer = gtk_timeout_add(500,(GtkFunction)Timer,0) ;
       gtk_widget_show(window_correlation);
       id_timer = gtk_idle_add((GtkFunction)Timer, 0);

    }
    else
    {
       gtk_widget_hide(window_correlation);
       //gtk_timeout_remove(id_timer);
       gtk_idle_remove(id_timer);

    }
    indic=!indic;
}

void
on_spinbutton_correlation_changed      (GtkEditable     *editable,
                                        gpointer         user_data)
{
    printf("zoom correlation changed\n");

}


void
on_spinbutton_images_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
    GtkWidget *wid;
    printf("zoom image changed\n");
    wid = lookup_widget((GtkWidget*)editable,"fixed_images");
    gtk_widget_queue_draw(wid);
}


GtkWidget*
create_opengl (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2)
{
    GtkWidget *WOpengl;
//    GtkWidget *wid;
//    gchar *text;
//    text = gtk_editable_get_chars(editable,0,-1);
//    seuil = atof(text);
    seuil = 8.0;    
    WOpengl = create_gl_window(NULL);		

    return WOpengl;
}


void
on_spinbutton_opengl_largeur_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
    GtkWidget *wid;
    gchar *text;
    float size;
    int height,width;
    text = gtk_editable_get_chars(editable,0,-1);
    size = atof(text);
    wid = lookup_widget((GtkWidget*)editable,"custom_opengl");
    gtk_widget_get_size_request(wid,&width,&height);
    gtk_widget_set_size_request(wid,size,height);
    gtk_widget_queue_draw(wid);
}


void
on_spinbutton_openglhauteur_changed    (GtkEditable     *editable,
                                        gpointer         user_data)
{
    GtkWidget *wid;
    gchar *text;
    float size;
    int height,width;
    text = gtk_editable_get_chars(editable,0,-1);
    size = atof(text);
    wid = lookup_widget((GtkWidget*)editable,"custom_opengl");
    gtk_widget_get_size_request(wid,&width,&height);
    gtk_widget_set_size_request(wid,width,size);
    gtk_widget_queue_draw(wid);
}


void
on_combobox_opengl_mode_changed        (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
    printf("Change combox box render mode content\n");
    printf("\t%d\n",gtk_combo_box_get_active(combobox));
    Mode = gtk_combo_box_get_active((GtkComboBox*)combobox);
}


void
on_spinbutton_opengl_seuil_changed     (GtkEditable     *editable,
                                        gpointer         user_data)
{
    GtkWidget *wid;
    gchar *text;
    text = gtk_editable_get_chars(editable,0,-1);
    seuil = atof(text);
    printf("seuil : %g\n",seuil);
    wid = lookup_widget((GtkWidget*)editable,"custom_opengl");
    gtk_widget_queue_draw(wid);
}

