
#include "openglgtk.h"
#include "opengl.h"
#include	<gtkgl/gtkglarea.h>
#include	<GL/gl.h>
#include	<GL/glu.h>
#include	<GL/glut.h>
#include	<gdk/gdk.h>
#include	<gdk/gdkkeysyms.h>
#include <math.h>
#include <stdio.h>
static GtkWidget	*glarea=NULL;

gint glarea_expose(GtkWidget *widget, GdkEventExpose *event)
{
	int gw,gh;
  /* ... Draw only last expose ... */
  if(event->count > 0) 
  {
    return TRUE;
  }
  gtk_widget_grab_focus(GTK_WIDGET(glarea));
  /* ... OpenGL calls can be done only if begingl returns true ... */
  if (gtk_gl_area_begingl(GTK_GL_AREA(glarea))) 
  {
  if (gtk_gl_area_make_current(GTK_GL_AREA(widget))) {
	PosEye(rx,ry,tz);
	gw = glarea->allocation.width;
	gh = glarea->allocation.height;
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective(	45.0,			// field of view in degree 
					(double)gw/(double)gh,			// aspect ratio 
					1,				// Z near 
					10000.0); 		// Z far 
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
/*	gluLookAt(	 xe, ze, ye,		// eye    
				0.0,0.0,0.0,		// center 
				0.0,1.0,0.0);		// up is in positive Y direction 
*/
	gluLookAt(	xe+xc, -ze+yc, ye+zc,		// eye    
			xc,yc,zc,							// center 
			0.0,yup,0.0);					// up is in positive Y direction 

       
     glEnable(GL_DEPTH_TEST);
     
        glClearColor(1, 1,1, 1);        
	glClear (GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
    /* ... DRAW STUFF HERE ... */
    DrawAxe();
//    DrawGrille();
   	DrawScene();
     glDisable(GL_DEPTH_TEST);
	glPushAttrib(GL_POINT_BIT);
	glColor3f(0,0,0);
	glPointSize(3);
		glBegin(GL_POINTS);
		glVertex3f(xc,yc,zc);
		glEnd();
	glPopAttrib();

//    printf("%d %d\n",glarea->allocation.width,glarea->allocation.height);
/*	glColor3f(1,0,0);
	glBegin(GL_LINES);
		glVertex2f(10,10);	
		glVertex2f(310,230);	
		glVertex2f(10,10);	
		glVertex2f(600,230);	
	glEnd();	
	glColor3f(0,1,0);
	glBegin(GL_LINES);
		glVertex2f(10,10);	
		glVertex2f(gw-10,gh-10);	
	glEnd();	
*/
//    glDrawBuffer(GL_FRONT_AND_BACK);
    /* opengl rendering done for now */
    gtk_gl_area_endgl(GTK_GL_AREA(glarea));
  gtk_gl_area_swapbuffers(GTK_GL_AREA(glarea));
  }
  }
  /* swap backbuffer to front */
  
  return TRUE;
}

gint glarea_configure(GtkWidget *widget, GdkEventConfigure *event)
{
  /* ... OpenGL calls can be done only if begingl returns true ... */
  if (gtk_gl_area_begingl(GTK_GL_AREA(widget))) {
    glViewport(0,0, widget->allocation.width, widget->allocation.height);

    /* ... End opengl calls by calling endgl ... */
    gtk_gl_area_endgl(GTK_GL_AREA(widget));
  }
  return TRUE;
}


gint glarea_motion_notify(GtkWidget *widget, GdkEventMotion *event)
{
	gint			x, y;
	GdkModifierType		state;
	int test;
  if (event->is_hint)
  {
    gdk_window_get_pointer(event->window, &x, &y, &state);
  }
  else
  {
    x = (gint)event->x;
    y = (gint)event->y;
    state = (GdkModifierType)event->state;
  }
  if(state & GDK_BUTTON1_MASK) 
  {
    /* ... Drag in progress, simulate trackball ... */
//    g_print("Mouse motion button 1 at coordinates (%d,%d)\n",x,y);
//	printf(" button 1, event %d, (%d %d)\n",event->type,x,y);
	if(fabs(x_mouse-x) > 1)
	{
		if(x<x_mouse)
			rx+=2;	
		else
			rx-=2;
	}
	if(fabs(y_mouse-y) > 1)
	{
		if(y<y_mouse)
			ry+=2;
		else
			ry-=2;
	}
    /* ... Orientation has changed, redraw mesh ... */
    gtk_widget_draw(glarea, (GdkRectangle *)NULL);
  }

  if(state & GDK_BUTTON2_MASK) 
  {
    /* ... Zooming drag ... */
//    g_print("Mouse motion button 2 at coordinates (%d,%d)\n",x,y);
    /* ... Zoom has changed, redraw mesh ... */
    gtk_widget_draw(glarea, (GdkRectangle *)NULL);
  }
  if(state & GDK_BUTTON3_MASK) 
  {
    /* ... 3rd button drag ... */
//    g_print("Mouse motion button 3 at coordinates (%d,%d)\n",x,y);
    //Zoom
	if(y<y_mouse)
		tz+=6;
	else
		tz-=6;
    /* ... Zoom has changed, redraw mesh ... */
    gtk_widget_draw(glarea, (GdkRectangle *)NULL);
  }
  // Mise à jour position souris
  x_mouse = x;
  y_mouse = y;
		if(ry<0)
			test = (int)(fabs(ry-180)/180)%2;
		if(ry>0)
			test = (int)(ry/180)%2;
		if(test)
			yup = +1;
		else
			yup = -1;

  return TRUE;
}


gint glarea_button_press(GtkWidget *widget, GdkEventButton *event)
{
	gint return_status=TRUE;
//	printf("%d %d\n",event->button,event->type);
	switch(event->type)
	{
		case GDK_BUTTON_PRESS:
			//g_print("Mouse button %d click at coordinates (%lf,%lf)\n",
			//event->button,event->x,event->y);
			break;
		case GDK_2BUTTON_PRESS:
//			printf("Mouse button %d double-click at coordinates (%lf,%lf)\n",
//			event->button,event->x,event->y);
			break;
		case GDK_3BUTTON_PRESS:
//			printf("Mouse button %d triple-click at coordinates (%lf,%lf)\n",
//			event->button,event->x,event->y);
			break;
		case GDK_BUTTON_RELEASE:
//			printf("relache\n");
			break;
		default:
//			printf("Unknown button press event\n");
			return_status=FALSE;
			break;
	}
	return(return_status);
}


gint glarea_key_press_event(GtkWidget *widget, GdkEventKey *event)
{
	static int ctrl=0;
//	printf("%x %c %d %d\n",event->keyval,event->keyval,event->state,event->send_event);
/*	if(event->state == GDK_DELETE)
		printf("appui touche\n");
	if(event->state == GDK_BUTTON_PRESS)
		printf("relache touche\n");
	if(event->state == GDK_KEY_PRESS)
		printf("APPUI touche\n");
*/		
	if(event->state == GDK_KEY_RELEASE)
	{
//		printf("RELACHE touche\n");
		return 0;
	}
	
  
	
  switch (event->keyval) 
  {
    case 'm':
      Mode = (Mode+1)%4;
//      printf("Mode : %d\n",Mode);
      break;
    
    case GDK_r:
//      g_print("Button r pressed...redrawing\n");
      gtk_widget_draw(glarea, (GdkRectangle *)NULL);
      break;
    case GDK_l:
//      g_print("Button l pressed...redrawing\n");
      gtk_widget_draw(glarea, (GdkRectangle *)NULL);
      break;
    case GDK_p:
//      g_print("Button p pressed...redrawing\n");
      gtk_widget_draw(glarea, (GdkRectangle *)NULL);
      break;
	case GDK_Left:
//      g_print("Button fleche gauche pressed...redrawing\n");
			xc -= 10;
      gtk_widget_draw(glarea, (GdkRectangle *)NULL);
      break;	
	case GDK_Right:
//      g_print("Button fleche droite pressed...redrawing\n");
			xc += 10;

      gtk_widget_draw(glarea, (GdkRectangle *)NULL);
      break;	
	case GDK_Up:
//      g_print("Button fleche haut pressed...redrawing\n");
		if(!ctrl)
			zc += 10;
		else
			yc += 10;	
		printf("%g\n",zc);
      gtk_widget_draw(glarea, (GdkRectangle *)NULL);
      break;	
	case GDK_Down:
//      g_print("Button fleche bas pressed...redrawing\n");
		if(!ctrl)
			zc -= 10;
		else
			yc -= 10;		
      gtk_widget_draw(glarea, (GdkRectangle *)NULL);
      break;	
	case GDK_Control_R:
		ctrl = !ctrl;
		break;
  }
  return (TRUE);
}


GtkWidget *create_gl_window(GtkWidget *parent)
{
	image_t *img_color,*img_depth;
  /* ... Create new OpenGL widget with GTK's window mode; analogous to
         glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
  */
  glarea = gtk_gl_area_new_vargs(NULL,	      /* no sharing */
				 GDK_GL_DOUBLEBUFFER,
				 GDK_GL_RGBA,
				 GDK_GL_DEPTH_SIZE,8,
				 
				 GDK_GL_NONE);/* last arg must be GDK_GL_NONE */
  if(!glarea) 
  { 
    g_print("Can't create GtkGlArea widget\n");
    return FALSE;
  }
  /* ... Set up events and signals for OpenGL widget ... */
  gtk_widget_set_events(GTK_WIDGET(glarea),
                        GDK_EXPOSURE_MASK|
                        GDK_BUTTON_PRESS_MASK|
                        GDK_BUTTON_RELEASE_MASK|
                        GDK_KEY_PRESS_MASK|
                        GDK_KEY_RELEASE_MASK|
			GDK_POINTER_MOTION_MASK|
			GDK_POINTER_MOTION_HINT_MASK);


  gtk_signal_connect (GTK_OBJECT(glarea), "expose_event",
                      GTK_SIGNAL_FUNC(glarea_expose), NULL);
  gtk_signal_connect (GTK_OBJECT(glarea), "motion_notify_event",
                      GTK_SIGNAL_FUNC(glarea_motion_notify), NULL);
  gtk_signal_connect (GTK_OBJECT(glarea), "button_press_event",
                      GTK_SIGNAL_FUNC(glarea_button_press), NULL);
  gtk_signal_connect (GTK_OBJECT(glarea), "button_release_event",
                      GTK_SIGNAL_FUNC(glarea_button_press), NULL);
  gtk_signal_connect (GTK_OBJECT(glarea), "configure_event",
                      GTK_SIGNAL_FUNC(glarea_configure), NULL);
  gtk_signal_connect (GTK_OBJECT(glarea), "key_press_event",
                      GTK_SIGNAL_FUNC(glarea_key_press_event), NULL);
//  gtk_signal_connect (GTK_OBJECT(glarea), "key_release_event",
//                      GTK_SIGNAL_FUNC(glarea_key_press_event), NULL);       
  gtk_signal_connect (GTK_OBJECT(glarea), "delete_event",
                      GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

  gtk_widget_set_usize(glarea, 320, 240); /* minimum size */
  gtk_quit_add_destroy(1, GTK_OBJECT(glarea));
  
  
  img_color = NULL;
  img_depth = NULL;

  if( parent)
  {
	  img_color = g_object_get_data ((GObject *)parent, "color");      
	  img_depth = g_object_get_data ((GObject *)parent, "depth");      
  }

  init_opengl(img_color,img_depth);
  
  return(glarea);
}
